<template>
  <div
    class="ui-input group relative z-0 flex flex-col text-base lg:text-lg xl:text-xl [&_.ui-form-errors_.errors]:-mt-1 [&_.ui-form-errors_.errors]:rounded-t-none [&_.ui-form-errors_.errors]:border-t-0 [&_.ui-form-errors_.errors]:pt-3 [&_.ui-form-hints_.hints]:mb-1"
    :class="[
      {
        'text-gray-500 [&_.ui-form-hints_.hints]:text-gray-400': disabled,
        'has-errors': hasErrors,
      },
      $attrs.class as string,
    ]"
    :style="$attrs.style as string"
  >
    <slot :label="label" :input-id="inputId" :required="required" name="label">
      <label
        :for="inputId"
        class="leading-relaxed motion-safe:transition-colors"
        :class="{
          'cursor-pointer': !disabled,
          'font-medium group-focus-within:text-violet-700': !hasErrors,
          'font-bold text-red-600 group-focus-within:text-red-700': hasErrors,
        }"
      >
        <span
          v-if="highlighted"
          aria-hidden="true"
          class="-ml-6 -mt-1 inline-block h-0 w-8 overflow-visible align-top text-2xl motion-safe:-ml-8 motion-safe:animate-point-right md:-ml-12 md:w-12 md:text-3xl"
          >👉</span
        >{{ label
        }}<span aria-hidden="true">{{ required ? '*' : '' }}</span></label
      >
    </slot>
    <slot :hints-id="hintsId" :hints="mergedHints" name="hints">
      <ui-form-hints :hints-id="hintsId" :hints="mergedHints" />
    </slot>
    <div
      class="relative z-10 [&_svg]:size-[1.25em] [&_svg]:fill-current [&_svg]:motion-safe:transition-colors"
    >
      <div
        v-if="$slots.iconLeft"
        class="pointer-events-none absolute left-2 top-[1.1rem] lg:left-3"
        :class="{
          'text-gray-500 group-focus-within:text-violet-500': !hasErrors,
          'text-red-600 group-focus-within:text-red-700': hasErrors,
        }"
      >
        <slot name="iconLeft" />
      </div>
      <input
        v-bind="{ ...filteredAttrs, ...filteredProps }"
        :id="inputId"
        :name="inputId"
        class="mt-1 w-full rounded border-2 px-4 py-3 text-base leading-tight shadow file:hidden focus:outline-none focus:ring-2 focus:ring-opacity-75 motion-safe:transition lg:text-lg lg:leading-tight xl:text-xl xl:leading-tight"
        :class="{
          'hover:cursor-pointer': !disabled && type === 'file',
          'cursor-not-allowed border-gray-300 bg-gray-50 shadow-none': disabled,
          'border-gray-400 focus:border-violet-700 focus:ring-violet-300 group-hover:border-violet-700':
            !hasErrors && !disabled,
          'focus:border-red-700 focus:ring-red-300 group-hover:border-red-700':
            hasErrors && !disabled,
          'border-red-500': hasErrors,
          'pl-8 lg:pl-10 xl:pl-12': $slots.iconLeft,
          'pr-8 lg:pr-10 xl:pr-12': $slots.iconRight,
        }"
        :style="inputAddonStyle"
        :aria-required="required"
        :aria-describedby="`${hintsId} ${errorsId}`"
        :aria-invalid="hasErrors"
      />
      <div
        v-if="$slots.iconRight"
        class="pointer-events-none absolute right-2 top-[1.1rem] lg:right-3"
        :class="{
          'text-gray-500 group-focus-within:text-violet-500': !hasErrors,
          'text-red-600 group-focus-within:text-red-700': hasErrors,
        }"
      >
        <slot name="iconRight" />
      </div>
      <div
        v-else-if="$slots.addon || addonLabel"
        ref="addonRef"
        class="pointer-events-none absolute right-1 top-[0.875rem] border-l-2 py-1 pl-4 pr-3 text-base font-medium leading-tight lg:text-lg lg:leading-tight xl:text-xl xl:leading-tight"
        :class="{
          'border-gray-400 text-gray-600 ': !disabled,
          'border-gray-300 text-gray-400': disabled,
        }"
      >
        <slot
          name="addon"
          :addon-label="addonLabel"
          :disabled="disabled"
          :has-errors="hasErrors"
        >
          <span aria-hidden="true">{{ addonLabel }}</span>
        </slot>
      </div>
    </div>
    <slot :errors-id="errorsId" :errors="parsedErrors" name="errors">
      <ui-form-errors :errors-id="errorsId" :errors="parsedErrors" />
    </slot>
  </div>
</template>

<script lang="ts" setup>
import { computed, PropType, ref, useAttrs, useSlots } from 'vue'
import { useElementSize } from '@vueuse/core'
import {
  useFormElementErrors,
  useFormElementId,
  useInputProps,
} from '../../composables'
import UiFormHints from './FormHints.vue'
import UiFormErrors from './FormErrors.vue'

defineOptions({
  name: 'UiInput',
  inheritAttrs: false,
})

const props = defineProps({
  // eslint-disable-next-line vue/valid-define-props
  ...useInputProps(),
  addonLabel: {
    type: [String, undefined] as PropType<string | undefined>,
    default: undefined,
  },
})

const emit = defineEmits(['update:modelValue'])

const filteredProps = computed(() => {
  const {
    name,
    label,
    hints,
    errors,
    modelValue,
    addonLabel,
    touched,
    setTouched,
    ...filteredProps
  } = props
  return {
    ...filteredProps,
    // note: file inputs don't support programmatically setting the value prop (security)
    ...(props.type !== 'file' ? { value: modelValue } : {}),
    onInput: ($event: Event) =>
      emit(
        'update:modelValue',
        props.type !== 'file'
          ? ($event.target as HTMLInputElement).value
          : ($event.target as HTMLInputElement).files,
      ),
  }
})

const filteredAttrs = computed(() => {
  const { class: _, style, onBlur, ...filteredAttrs } = useAttrs()
  return {
    ...filteredAttrs,
    onBlur: ($event: FocusEvent) => {
      typeof props.setTouched === 'function' && props.setTouched(true) // vee-validate blur handler
      typeof onBlur === 'function' && onBlur($event) // native blur handler
    },
  }
})

const mergedHints = computed(() => [
  ...(props.highlightedHint ? [props.highlightedHint] : []),
  ...(Array.isArray(props.hints) ? props.hints : [props.hints]),
])

const { uniqueId, errorsId, hintsId } = useFormElementId(props)

const inputId = computed(() => props.name || uniqueId)

const { hasErrors, parsedErrors } = useFormElementErrors(props)

const addonRef = ref(null)
const { width: addonWidth } = useElementSize(addonRef)
const slots = useSlots()

const inputAddonStyle = computed(() => {
  if (!addonWidth.value && !slots.iconRight) {
    return undefined
  }

  return `padding-right: calc(${Math.round(addonWidth.value)}px + 3rem)`
})
</script>
